#!/bin/bash
# Check this file
OPSIUPDATELOG=/var/log/opsi/opsi-product-updater.log
# Set default error level
LEVEL=0

# Select only entries where timestamp matches filedate
OPSIUPDATELOGTODAYONLY=$(grep "^$(LANG=C ls -go --time-style='+%b %d' $OPSIUPDATELOG | awk '{print $4 " " $5}')" $OPSIUPDATELOG)

# grep entries of updated packages and select their names
OPSIUPDATEDPACKAGES=$(echo -e "$OPSIUPDATELOGTODAYONLY" | grep "download of package is required" | awk '{ print $5 }')

# greps entries that aren't merely notices
OPSIUPDATEERRORS=$(echo -e "$OPSIUPDATELOGTODAYONLY" | grep -v "\[notice\]")

# If anything was found, report it
if [ $(echo -e "$OPSIUPDATEDPACKAGES" | wc -m) -gt 1 ] ; then
	# do something here (notify someone somehow)
#	echo -e "List of updated packages:\n$OPSIUPDATEDPACKAGES\n"
    LEVEL=1
fi

# If anything was found, report it
if [ $(echo -e "$OPSIUPDATERRORS" | wc -m) -gt 1 ] ; then
	# do something here (notify someone somehow)
#	echo -e "Errors:\n$OPSIUPDATERRORS\n"
	LEVEL=2
fi

#exit $LEVEL

#
# oben alle Ausgaben und exits auskommentiert und
# Variable LEVEL hier fuer Nagios Check noch mal ausgewertet 
#

case $LEVEL in
[0]*)
  echo "OK"
  exit 0
  ;;
[1]*)
  echo "WARNING - $OPSIUPDATEDPACKAGES"
  exit 1
  ;;
[2]*)
  echo "CRITICAL - $OPSIUPDATERRORS"
  exit 2
  ;;
*)
  echo "CRITICAL - unknown error"
  exit 2
  ;;
#*)
#  echo "UNKNOWN"
#  exit 3
#  ;;
esac

